#include <FastSPI_LED2.h>

//Set the number of leds in the strip.
#define NUM_LEDS 120

// Sometimes chipsets wire in a backwards sort of way
//struct CRGB { 
//  unsigned char g; 
//  unsigned char b; 
//  unsigned char r; 
// };
// struct CRGB { unsigned char r; unsigned char g; unsigned char b; };
//struct CRGB *leds; alt
struct CRGB leds[NUM_LEDS];

#define PIN 4
#define DATA_PIN 11
#define CLOCK_PIN 13

void setup(){
  Serial.begin(115200);
  //FastSPI_LED.setLeds(NUM_LEDS); alt
  //Change this to match your led strip
  LEDS.addLeds<WS2812B, 11>(leds, NUM_LEDS);

  LEDS.show();
  clearLeds();
}

int readByte(){
  return Serial.read();
}

void clearLeds(){
  for(int tmpChannel=0; tmpChannel<NUM_LEDS; tmpChannel++){
    leds[tmpChannel].r = 0;
    leds[tmpChannel].b = 0;
    leds[tmpChannel].g = 0;  
  };
}

//For testing LEDS without RS232 just start this in loop()
void FirstLight(){
       // Move a single white led 
       for(int whiteLed = 0; whiteLed < NUM_LEDS; whiteLed = whiteLed + 1) {
      // Turn our current led on to white, then show the leds
      leds[whiteLed] = CRGB::White;

      // Show the leds (only one of which is set to white, from above)
      FastLED.show();

      // Wait a little bit
      delay(100);

      // Turn our current led back to black for the next loop around
      leds[whiteLed] = CRGB::Black;
   }
}   

void loop(){
  //FirstLight();
  
  if(readByte() == 0xFF){
    if(readByte() == 0x00){
      if(readByte() == 0x00){
        int channels = readByte();
        for(int channel=0; channel<channels; channel++){
          leds[channel].g = readByte();
          leds[channel].r = readByte();
          leds[channel].b = readByte();
        }
        FastSPI_LED.show();
      }
    }
  }
  else
  {
  }
}
